use File::Spec;  # always use File::Spec, especially in tests (portable)
use File::Path;
use Config;
use Test;
BEGIN { plan tests => 20 };


use PerlBin;
BEGIN { ok(1); }

my $script = File::Spec->catfile(qw[ t 0-basic.t ]);
my $binary = File::Spec->catfile(qw[ deleteme 0-basic.dat ]);

# these files must exist (the perl dynamic link library and PerlBin.dat)
ok(-e File::Spec->catfile( $Config{installbin}, $PerlBin::PerlSO ) );
ok(-e $PerlBin::DAT );

# and now to test the interface
my $pB;
ok( $pB = PerlBin->new() );
ok( $pB = PerlBin->new( $script ) );
ok( exists $pB->{deps}->{'strict.pm'} ); # it must, see 0-basic.t


ok( $pB = PerlBin->new() );
ok( $pB->scan_deps($script) );
ok( $pB->clear_deps() );
ok( $pB->add_deps('strict.pm') );


# the ultimate test
ok( $pB = PerlBin->new($script) );
ok( mkpath 'deleteme' );
ok( $pB->PutSO('deleteme') );
ok( $pB->PutDeps('deleteme') );
ok( $pB->PutBinary( $script => $binary ) );
ok( rmtree 'deleteme' );

# and the short version ;D
ok( mkpath 'deleteme' );
ok( PerlBin->new( $script => $binary ) );
ok( rmtree 'deleteme' );

# and the choo-choo
ok(
    mkpath 'deleteme' and
    PerlBin->new()
        ->scan_deps( $script )
        ->PutSO('deleteme')
        ->PutDeps('deleteme')
        ->PutBinary( $script => $binary ) 
    and rmtree 'deleteme'
);

# yay, 20 test all rockin
#eval q[us].q[e Data::Dumper;warn"\n\n".Dumper($pB)."\n\n"]; # foil Module::ScanDeps ;)

